xmonad-contrib-0.12: Third party extensions for xmonad

Copyright | (c) Roman Cheplyaka, Ivan N. Veselov <veselov@gmail.com>
License | BSD-style (see LICENSE)
Maintainer | Roman Cheplyaka <roma@ro-che.info>
Stability | unstable
Portability | unportable
Safe Haskell | None
Language | Haskell98

XMonad.Layout.IM

Contents

- Usage
- Hints
- TODO

Description

Layout modfier suitable for workspace with multi-windowed instant messenger (like Psi or Tkabber).

Synopsis

- data Property
  - = Title String
  - | ClassName String
  - | Resource String
  - | Role String
  - | Machine String
  - | And Property Property
  - | Or Property Property
  - | Not Property
  - | Const Bool
- data IM a = IM Rational Property
- withIM :: LayoutClass l a => Rational -> Property -> l a -> ModifiedLayout AddRoster l a
- gridIM :: Rational -> Property -> ModifiedLayout AddRoster Grid a
- data AddRoster a

# Usage

You can use this module with the following in your `~/.xmonad/xmonad.hs`:

    import XMonad.Layout.IM
    import Data.Ratio ((%))

Then edit your `layoutHook` by adding IM modifier to layout which you prefer for managing your chat windows (Grid in this example, another useful choice to consider is Tabbed layout).

    myLayout = withIM (1%7) (ClassName "Tkabber") Grid ||| Full ||| etc..
    main = xmonad def { layoutHook = myLayout }

Here `1%7` is the part of the screen which your roster will occupy, `ClassName "Tkabber"` tells xmonad which window is actually your roster.

Screenshot: http://haskell.org/haskellwiki/Image:Xmonad-layout-im.png

For more detailed instructions on editing the layoutHook see:

XMonad.Doc.Extending

# Hints

To launch IM layout automatically on your IM workspace use XMonad.Layout.PerWorkspace.

By default the roster window will appear on the left side. To place roster window on the right side, use `reflectHoriz` from XMonad.Layout.Reflect module.

# TODO

This item are questionable. Please let me know if you find them useful.

- shrink/expand

data Property Source

Most of the property constructors are quite self-explaining.

Constructors

Title String |
ClassName String |
Resource String |
Role String | WM_WINDOW_ROLE property
Machine String | WM_CLIENT_MACHINE property
And Property Property infixr 9 |
Or Property Property infixr 8 |
Not Property |
Const Bool |

Instances

Read Property Source |
Show Property Source |
Predicate Property Window Source |

data IM a Source

This is for compatibility with old configs only and will be removed in future versions!

Constructors

IM Rational Property |

Instances

LayoutClass IM Window Source |
Read (IM a) Source |
Show (IM a) Source |

withIM :: LayoutClass l a => Rational -> Property -> l a -> ModifiedLayout AddRoster l a Source

Modifier which converts given layout to IM-layout (with dedicated space for roster and original layout for chat windows)

gridIM :: Rational -> Property -> ModifiedLayout AddRoster Grid a Source

IM layout modifier applied to the Grid layout

data AddRoster a Source

Data type for LayoutModifier which converts given layout to IM-layout (with dedicated space for the roster and original layout for chat windows)

Instances

LayoutModifier AddRoster Window Source |
Read (AddRoster a) Source |
Show (AddRoster a) Source |